var Thread = {
	init: function()
	{
		if(!Thread.loaded)
		{
			Thread.loaded = true;
			Thread.qeCache = new Array();
			Thread.initMultiQuote();
		}
	},
	
	initMultiQuote: function()
	{
		Thread.init();
		
		var quoted = Cookie.get("multiquote");
		if(quoted)
		{
			var post_ids = quoted.split("|");
			for(var i=0; i < post_ids.length; i++)
			{
				if(post_ids[i] != '')
				{
					if($("multiquote_"+post_ids[i]))
					{
						element = $("multiquote_"+post_ids[i]);
						element.src = element.src.replace("postbit_multiquote.gif", "postbit_multiquote_on.gif");
					}
				}
			}
			if($('quickreply_multiquote'))
			{
				$('quickreply_multiquote').style.display = '';
			}
		}
		return true;
	},
	
	multiQuote: function(pid)
	{
		Thread.init();
		
		var new_post_ids = new Array();
		var quoted = Cookie.get("multiquote");
		var is_new = true;
		if(quoted)
		{
			var post_ids = quoted.split("|");
			for(var i = 0; i < post_ids.length; i++)
			{
				if(post_ids[i] != pid && post_ids[pid] != '')
				{
					new_post_ids[new_post_ids.length] = post_ids[i];
				}
				else if(post_ids[i] == pid)
				{
					is_new = false;
				}
			}
		}
		element = $("multiquote_"+pid);
		if(is_new == true)
		{
			element.src = element.src.replace("postbit_multiquote.gif", "postbit_multiquote_on.gif");
			new_post_ids[new_post_ids.length] = pid;
		}
		else
		{
			element.src = element.src.replace("postbit_multiquote_on.gif", "postbit_multiquote.gif");
		}
		if($('quickreply_multiquote'))
		{
			if(new_post_ids.length > 0)
			{
				$('quickreply_multiquote').style.display = '';
			}
			else
			{
				$('quickreply_multiquote').style.display = 'none';
			}
		}
		Cookie.set("multiquote", new_post_ids.join("|"));
	},
	
	loadMultiQuoted: function()
	{
		Thread.init();
		
		tid = document.input.tid.value;
		this.spinner = new ActivityIndicator("body", {image: "images/spinner_big.gif"});
		new ajax('xmlhttp.php?action=get_multiquoted&load_all=1&tid='+tid, {method: 'get', onComplete: function(request) {Thread.multiQuotedLoaded(request); }});		
	},
	
	multiQuotedLoaded: function(request)
	{
		Thread.init();
		
		if(request.responseText.match(/<error>(.*)<\/error>/))
		{
			message = request.responseText.match(/<error>(.*)<\/error>/);
			if(!message[1])
			{
				message[1] = "An unknown error occurred.";
			}
			if(this.spinner)
			{
				this.spinner.destroy();
				this.spinner = '';
			}
			alert('There was an error fetching the posts.\n\n'+message[1]);
		}
		else if(request.responseText)
		{
			var id = 'message';
			if(typeof clickableEditor != 'undefined')
			{
				id = clickableEditor.textarea;
			}
			if($(id).value)
			{
				$(id).value += "\n";
			}
			$(id).value += request.responseText;
		}
		Thread.clearMultiQuoted();
		$('quickreply_multiquote').style.display = 'none';
		document.input.quoted_ids.value = 'all';
		if(this.spinner)
		{
			this.spinner.destroy();
			this.spinner = '';
		}
		$('message').focus();	
	},
	
	clearMultiQuoted: function()
	{
		Thread.init();
		
		$('quickreply_multiquote').style.display = 'none';
		var quoted = Cookie.get("multiquote");
		if(quoted)
		{
			var post_ids = quoted.split("|");
			for(var i=0; i < post_ids.length; i++)
			{
				if(post_ids[i] != '')
				{
					if($("multiquote_"+post_ids[i]))
					{
						element = $("multiquote_"+post_ids[i]);
						element.src = element.src.replace("postbit_multiquote_on.gif", "postbit_multiquote.gif");
					}
				}
			}
		}
		Cookie.unset('multiquote');
	},	

	deletePost: function(pid)
	{
		Thread.init();
		
		confirmReturn = confirm(quickdelete_confirm);
		if(confirmReturn == true) {
			form = document.createElement("form");
			form.setAttribute("method", "post");
			form.setAttribute("action", "editpost.php?action=deletepost&delete=yes");
			form.setAttribute("style", "display: none;");

			var input = document.createElement("input");
			input.setAttribute("name", "pid");
			input.setAttribute("type", "hidden");
			input.setAttribute("value", pid);

			form.appendChild(input);
			document.getElementsByTagName("body")[0].appendChild(form);
			form.submit();
		}
	},
	
	reportPost: function(pid)
	{
		Thread.init();
		
		MyBB.popupWindow("report.php?pid="+pid, "reportPost", 400, 300)
	},
	
	quickEdit: function(pid)
	{
		Thread.init();
		
		if(!$("pid_"+pid))
		{
			return false;
		}
		if(Thread.qeCache[pid])
		{
			return false;
		}
		Thread.qeCache[pid] = $("pid_"+pid).innerHTML;
		this.spinner = new ActivityIndicator("body", {image: "images/spinner_big.gif"});
		new ajax('xmlhttp.php?action=edit_post&do=get_post&pid='+pid, {method: 'get', onComplete: function(request) { Thread.quickEditLoaded(request, pid); }});
		return false;
	},
	
	quickEditLoaded: function(request, pid)
	{
		Thread.init();
		
		if(request.responseText.match(/<error>(.*)<\/error>/))
		{
			message = request.responseText.match(/<error>(.*)<\/error>/);
			if(!message[1])
			{
				message[1] = "An unknown error occurred.";
			}
			if(this.spinner)
			{
				this.spinner.destroy();
				this.spinner = '';
			}
			alert('There was an error performing the update.\n\n'+message[1]);
			Thread.qeCache[pid] = "";
		}
		else if(request.responseText)
		{
			$("pid_"+pid).innerHTML = request.responseText;
			element = $("quickedit_"+pid);
			element.focus();
			offsetTop = -60;
			do
			{
				offsetTop += element.offsetTop || 0;
				element = element.offsetParent;
			}
			while(element);

			scrollTo(0, offsetTop);
		}
		if(this.spinner)
		{
			this.spinner.destroy();
			this.spinner = '';
		}
	},
	
	quickEditSave: function(pid)
	{
		Thread.init();
		
		message = $("quickedit_"+pid).value;
		if(message == "")
		{
			return false;
		}
		this.spinner = new ActivityIndicator("body", {image: "images/spinner_big.gif"});
		
		postData = "value="+encodeURIComponent(message).replace(/\+/g, "%2B");
		new ajax('xmlhttp.php?action=edit_post&do=update_post&pid='+pid, {method: 'post', postBody: postData, onComplete: function(request) { Thread.quickEditSaved(request, pid); }});		
	},
	
	quickEditCancel: function(pid)
	{
		Thread.init();
		
		$("pid_"+pid).innerHTML = Thread.qeCache[pid];
		Thread.qeCache[pid] = "";
		if(this.spinner)
		{
			this.spinner.destroy();
			this.spinner = '';
		}
	},
	
	quickEditSaved: function(request, pid)
	{
		Thread.init();
		
		if(request.responseText.match(/<error>(.*)<\/error>/))
		{
			message = request.responseText.match(/<error>(.*)<\/error>/);
			if(!message[1])
			{
				message[1] = "An unknown error occurred.";
			}
			if(this.spinner)
			{
				this.spinner.destroy();
				this.spinner = '';
			}
			alert('There was an error performing the update.\n\n'+message[1]);
		}
		else if(request.responseText)
		{
			$("pid_"+pid).innerHTML = request.responseText;
			Thread.qeCache[pid] = "";
		}
		if(this.spinner)
		{
			this.spinner.destroy();
			this.spinner = '';
		}
	},
	
	quickReply: function()
	{
		if($("message").form.preview) return true;
		// IE can't do AJAX quick replies :P
		if(navigator.appVersion.indexOf("MSIE")!=-1) return true;
		Thread.init();
		
		var postData = '';
		
		// build postdata from form
		postFormElems = $("message").form.elements;
		for(i=0; i<postFormElems.length; i++)
		{
			if(postFormElems[i].name=="message" || postFormElems[i].name=="subject")
			{
				if(!(textToSend = postFormElems[i].value))
					return false;
				postData += ((i==0)?"":'&') + postFormElems[i].name + "=" + encodeURIComponent(textToSend).replace(/\+/g, "%2B");
			}
			else if(postFormElems[i].type == "checkbox")
				postData += ((i==0)?"":'&') + postFormElems[i].name + "=" + ((postFormElems[i].checked) ? postFormElems[i].value : "");
			else if(postFormElems[i].type == "submit")
				postFormElems[i].disabled = true;
			else
				postData += ((i==0)?"":'&') + postFormElems[i].name + "=" + postFormElems[i].value;
		}
		
		this.spinner = new ActivityIndicator("body", {image: "images/spinner_big.gif"});
		
		new ajax('xmlhttp.php?nul=nul', {method: 'post', postBody: postData, onComplete: function(request) { Thread.quickReplyPosted(request); }});
		
		return false;
	},
	
	quickReplyPosted: function(request)
	{	
		if(request.responseText.match(/<error>(.*)<\/error>/))
		{
			message = request.responseText.match(/<error>(.*)<\/error>/);
			if(!message[1])
			{
				message[1] = "An unknown error occurred.";
			}
			if(this.spinner)
			{
				this.spinner.destroy();
				this.spinner = '';
			}
			alert('There was an error performing the update.\n\n'+message[1]);
		}
		else if(request.responseText.match(/<message redirect=\"(.*)\">(.*)<\/message>/))
		{
			message = request.responseText.match(/<message redirect=\"(.*)\">(.*)<\/message>/);
			if(this.spinner)
			{
				this.spinner.destroy();
				this.spinner = '';
			}
			if(confirm(message[2])) location.href = message[1];
		}
		else if(request.responseText.match(/<message>(.*)<\/message>/))
		{
			message = request.responseText.match(/<message>(.*)<\/message>/);
			if(this.spinner)
			{
				this.spinner.destroy();
				this.spinner = '';
			}
			alert(message[1]);
		}
		else if(request.responseText.match(/<redirect>(.*)<\/redirect>/))
		{
			message = request.responseText.match(/<redirect>(.*)<\/redirect>/);
			if(this.spinner)
			{
				this.spinner.destroy();
				this.spinner = '';
			}
			location.href = message[1];
			return 0;
		}
		else if(request.responseText)
		{
			// add a new post
			$("ajaxqr").innerHTML += request.responseText;
			//update form elements
			document.input.time.value = request.getResponseHeader("ajaxqr_time");
			document.input.postcount.value = request.getResponseHeader("ajaxqr_postcount");
			document.input.posthash.value = request.getResponseHeader("ajaxqr_posthash");
			document.input.message.value = "";
			
			// enable submit buttons
			var postFormElems = $("message").form.elements;
			for(i=0; i < postFormElems.length; i++)
				if(postFormElems[i].type == "submit")
					postFormElems[i].disabled = false;
			
			// quickedit menus & inline mod fixes
			var pidArray = request.getResponseHeader("ajaxqr_pids").split(' ');
			for(i=0; i<pidArray.length; i++)
			{
				new PopupMenu("edit_post_"+pidArray[i]);
				Event.observe($("inlinemod_"+pidArray[i]), "click", inlineModeration.checkItem);
			}
		}
		if(this.spinner)
		{
			this.spinner.destroy();
			this.spinner = '';
		}
	}
}
Thread.loaded = false;
Event.observe(window, 'load', Thread.init);